package commonj.sdo;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Date;
import java.util.List;
/**
  This interface contains methods that have been deprecated from the DataObject interface, but which continue to be
  supported in SDO 3.0.
  @deprecated
*/
public interface TypedAccessors {

	/**
	 * Returns the value of a <code>boolean</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>boolean</code> value of the specified property.
	 * @see #get(String)
	 */
	boolean getBoolean(String path);

	/**
	 * Returns the value of a <code>byte</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>byte</code> value of the specified property.
	 * @see #get(String)
	 */
	byte getByte(String path);

	/**
	 * Returns the value of a <code>char</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>char</code> value of the specified property.
	 * @see #get(String)
	 */
	char getChar(String path);

	/**
	 * Returns the value of a <code>double</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>double</code> value of the specified property.
	 * @see #get(String)
	 */
	double getDouble(String path);

	/**
	 * Returns the value of a <code>float</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>float</code> value of the specified property.
	 * @see #get(String)
	 */
	float getFloat(String path);

	/**
	 * Returns the value of a <code>int</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>int</code> value of the specified property.
	 * @see #get(String)
	 */
	int getInt(String path);

	/**
	 * Returns the value of a <code>long</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>long</code> value of the specified property.
	 * @see #get(String)
	 */
	long getLong(String path);

	/**
	 * Returns the value of a <code>short</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>short</code> value of the specified property.
	 * @see #get(String)
	 */
	short getShort(String path);

	/**
	 * Returns the value of a <code>byte[]</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>byte[]</code> value of the specified property.
	 * @see #get(String)
	 */
	byte[] getBytes(String path);

	/**
	 * Returns the value of a <code>BigDecimal</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>BigDecimal</code> value of the specified property.
	 * @see #get(String)
	 */
	BigDecimal getBigDecimal(String path);

	/**
	 * Returns the value of a <code>BigInteger</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>BigInteger</code> value of the specified property.
	 * @see #get(String)
	 */
	BigInteger getBigInteger(String path);

	/**
	 * Returns the value of a <code>DataObject</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>DataObject</code> value of the specified property.
	 * @see #get(String)
	 */
	DataObject getDataObject(String path);

	/**
	 * Returns the value of a <code>Date</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>Date</code> value of the specified property.
	 * @see #get(String)
	 */
	Date getDate(String path);

	/**
	 * Returns the value of a <code>String</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>String</code> value of the specified property.
	 * @see #get(String)
	 */
	String getString(String path);

	/**
	 * Returns the value of a <code>List</code> property identified by the specified path.
	 * @param path the path to a valid object and property.
	 * @return the <code>List</code> value of the specified property.
	 * @see #get(String)
	 */
	List<? extends Object> getList(String path);

	/**
	 * @see #getSequence()
	 * Returns the value of a <code>Sequence</code> property identified by the specified path.
	 * An implementation may throw an UnsupportedOperationException.
	 * @param path the path to a valid object and property.
	 * @return the <code>Sequence</code> value of the specified property.
	 * @see #get(String)
	 * @deprecated in 2.1.0.
	 */
	Sequence getSequence(String path);

	/**
	 * Sets the value of a <code>boolean</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setBoolean(String path, boolean value);

	/**
	 * Sets the value of a <code>byte</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setByte(String path, byte value);

	/**
	 * Sets the value of a <code>char</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setChar(String path, char value);

	/**
	 * Sets the value of a <code>double</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setDouble(String path, double value);

	/**
	 * Sets the value of a <code>float</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setFloat(String path, float value);

	/**
	 * Sets the value of a <code>int</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setInt(String path, int value);

	/**
	 * Sets the value of a <code>long</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setLong(String path, long value);

	/**
	 * Sets the value of a <code>short</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setShort(String path, short value);

	/**
	 * Sets the value of a <code>byte[]</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setBytes(String path, byte[] value);

	/**
	 * Sets the value of a <code>BigDecimal</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setBigDecimal(String path, BigDecimal value);

	/**
	 * Sets the value of a <code>BigInteger</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setBigInteger(String path, BigInteger value);

	/**
	 * Sets the value of a <code>DataObject</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setDataObject(String path, DataObject value);

	/**
	 * Sets the value of a <code>Date</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setDate(String path, Date value);

	/**
	 * Sets the value of a <code>String</code> property identified by the specified path, to the specified value.
	 * @param path the path to a valid object and property.
	 * @param value the new value for the property.
	 * @see #set(String, Object)
	 */
	void setString(String path, String value);

	/**
	 * Returns the value of a <code>boolean</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>boolean</code> value of the specified property.
	 * @see #get(int)
	 */
	boolean getBoolean(int propertyIndex);

	/**
	 * Returns the value of a <code>byte</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>byte</code> value of the specified property.
	 * @see #get(int)
	 */
	byte getByte(int propertyIndex);

	/**
	 * Returns the value of a <code>char</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>char</code> value of the specified property.
	 * @see #get(int)
	 */
	char getChar(int propertyIndex);

	/**
	 * Returns the value of a <code>double</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>double</code> value of the specified property.
	 * @see #get(int)
	 */
	double getDouble(int propertyIndex);

	/**
	 * Returns the value of a <code>float</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>float</code> value of the specified property.
	 * @see #get(int)
	 */
	float getFloat(int propertyIndex);

	/**
	 * Returns the value of a <code>int</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>int</code> value of the specified property.
	 * @see #get(int)
	 */
	int getInt(int propertyIndex);

	/**
	 * Returns the value of a <code>long</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>long</code> value of the specified property.
	 * @see #get(int)
	 */
	long getLong(int propertyIndex);

	/**
	 * Returns the value of a <code>short</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>short</code> value of the specified property.
	 * @see #get(int)
	 */
	short getShort(int propertyIndex);

	/**
	 * Returns the value of a <code>byte[]</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>byte[]</code> value of the specified property.
	 * @see #get(int)
	 */
	byte[] getBytes(int propertyIndex);

	/**
	 * Returns the value of a <code>BigDecimal</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>BigDecimal</code> value of the specified property.
	 * @see #get(int)
	 */
	BigDecimal getBigDecimal(int propertyIndex);

	/**
	 * Returns the value of a <code>BigInteger</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>BigInteger</code> value of the specified property.
	 * @see #get(int)
	 */
	BigInteger getBigInteger(int propertyIndex);

	/**
	 * Returns the value of a <code>DataObject</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>DataObject</code> value of the specified property.
	 * @see #get(int)
	 */
	DataObject getDataObject(int propertyIndex);

	/**
	 * Returns the value of a <code>Date</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>Date</code> value of the specified property.
	 * @see #get(int)
	 */
	Date getDate(int propertyIndex);

	/**
	 * Returns the value of a <code>String</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>String</code> value of the specified property.
	 * @see #get(int)
	 */
	String getString(int propertyIndex);

	/**
	 * Returns the value of a <code>List</code> property identified by the specified property index.
	 * @param propertyIndex the index of the property.
	 * @return the <code>List</code> value of the specified property.
	 * @see #get(int)
	 */
	List<? extends Object> getList(int propertyIndex);

	/**
	 * @see #getSequence()
	 * Returns the value of a <code>Sequence</code> property identified by the specified property index.
	 * An implementation may throw an UnsupportedOperationException.
	 * @param propertyIndex the index of the property.
	 * @return the <code>Sequence</code> value of the specified property.
	 * @see #get(int)
	 * @deprecated in 2.1.0.
	 */
	Sequence getSequence(int propertyIndex);

	/**
	 * Sets the value of a <code>boolean</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setBoolean(int propertyIndex, boolean value);

	/**
	 * Sets the value of a <code>byte</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setByte(int propertyIndex, byte value);

	/**
	 * Sets the value of a <code>char</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setChar(int propertyIndex, char value);

	/**
	 * Sets the value of a <code>double</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setDouble(int propertyIndex, double value);

	/**
	 * Sets the value of a <code>float</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setFloat(int propertyIndex, float value);

	/**
	 * Sets the value of a <code>int</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setInt(int propertyIndex, int value);

	/**
	 * Sets the value of a <code>long</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setLong(int propertyIndex, long value);

	/**
	 * Sets the value of a <code>short</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setShort(int propertyIndex, short value);

	/**
	 * Sets the value of a <code>byte[]</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setBytes(int propertyIndex, byte[] value);

	/**
	 * Sets the value of a <code>BigDecimal</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setBigDecimal(int propertyIndex, BigDecimal value);

	/**
	 * Sets the value of a <code>BigInteger</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setBigInteger(int propertyIndex, BigInteger value);

	/**
	 * Sets the value of a <code>DataObject</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setDataObject(int propertyIndex, DataObject value);

	/**
	 * Sets the value of a <code>Date</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setDate(int propertyIndex, Date value);

	/**
	 * Sets the value of a <code>String</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 */
	void setString(int propertyIndex, String value);

	/**
	 * Sets the value of a <code>List</code> property identified by the specified property index, to the specified value.
	 * @param propertyIndex the index of the property.
	 * @param value the new value for the property.
	 * @see #set(int, Object)
	 * @see #setList(Property, List)
	 */
	void setList(int propertyIndex, List<? extends Object> value);

	/**
	 * Returns the value of the specified <code>boolean</code> property.
	 * @param property the property to get.
	 * @return the <code>boolean</code> value of the specified property.
	 * @see #get(Property)
	 */
	boolean getBoolean(Property property);

	/**
	 * Returns the value of the specified <code>byte</code> property.
	 * @param property the property to get.
	 * @return the <code>byte</code> value of the specified property.
	 * @see #get(Property)
	 */
	byte getByte(Property property);

	/**
	 * Returns the value of the specified <code>char</code> property.
	 * @param property the property to get.
	 * @return the <code>char</code> value of the specified property.
	 * @see #get(Property)
	 */
	char getChar(Property property);

	/**
	 * Returns the value of the specified <code>double</code> property.
	 * @param property the property to get.
	 * @return the <code>double</code> value of the specified property.
	 * @see #get(Property)
	 */
	double getDouble(Property property);

	/**
	 * Returns the value of the specified <code>float</code> property.
	 * @param property the property to get.
	 * @return the <code>float</code> value of the specified property.
	 * @see #get(Property)
	 */
	float getFloat(Property property);

	/**
	 * Returns the value of the specified <code>int</code> property.
	 * @param property the property to get.
	 * @return the <code>int</code> value of the specified property.
	 * @see #get(Property)
	 */
	int getInt(Property property);

	/**
	 * Returns the value of the specified <code>long</code> property.
	 * @param property the property to get.
	 * @return the <code>long</code> value of the specified property.
	 * @see #get(Property)
	 */
	long getLong(Property property);

	/**
	 * Returns the value of the specified <code>short</code> property.
	 * @param property the property to get.
	 * @return the <code>short</code> value of the specified property.
	 * @see #get(Property)
	 */
	short getShort(Property property);

	/**
	 * Returns the value of the specified <code>byte[]</code> property.
	 * @param property the property to get.
	 * @return the <code>byte[]</code> value of the specified property.
	 * @see #get(Property)
	 */
	byte[] getBytes(Property property);

	/**
	 * Returns the value of the specified <code>BigDecimal</code> property.
	 * @param property the property to get.
	 * @return the <code>BigDecimal</code> value of the specified property.
	 * @see #get(Property)
	 */
	BigDecimal getBigDecimal(Property property);

	/**
	 * Returns the value of the specified <code>BigInteger</code> property.
	 * @param property the property to get.
	 * @return the <code>BigInteger</code> value of the specified property.
	 * @see #get(Property)
	 */
	BigInteger getBigInteger(Property property);

	/**
	 * Returns the value of the specified <code>DataObject</code> property.
	 * @param property the property to get.
	 * @return the <code>DataObject</code> value of the specified property.
	 * @see #get(Property)
	 */
	DataObject getDataObject(Property property);

	/**
	 * Returns the value of the specified <code>Date</code> property.
	 * @param property the property to get.
	 * @return the <code>Date</code> value of the specified property.
	 * @see #get(Property)
	 */
	Date getDate(Property property);

	/**
	 * Returns the value of the specified <code>String</code> property.
	 * @param property the property to get.
	 * @return the <code>String</code> value of the specified property.
	 * @see #get(Property)
	 */
	String getString(Property property);

	/**
	 * Returns the value of the specified <code>List</code> property.
	 * The List returned contains the current values.
	 * Updates through the List interface operate on the current values of the DataObject.
	 * Each access returns the same List object.
	 * @param property the property to get.
	 * @return the <code>List</code> value of the specified property.
	 * @see #get(Property)
	 */
	List<? extends Object> getList(Property property);

	/**
	 * @see #getSequence()
	 * Returns the value of the specified <code>Sequence</code> property.
	 * An implementation may throw an UnsupportedOperationException.
	 * @param property the property to get.
	 * @return the <code>Sequence</code> value of the specified property.
	 * @see #get(Property)
	 * @deprecated in 2.1.0.
	 */
	Sequence getSequence(Property property);

	/**
	 * Sets the value of the specified <code>boolean</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setBoolean(Property property, boolean value);

	/**
	 * Sets the value of the specified <code>byte</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setByte(Property property, byte value);

	/**
	 * Sets the value of the specified <code>char</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setChar(Property property, char value);

	/**
	 * Sets the value of the specified <code>double</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setDouble(Property property, double value);

	/**
	 * Sets the value of the specified <code>float</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setFloat(Property property, float value);

	/**
	 * Sets the value of the specified <code>int</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setInt(Property property, int value);

	/**
	 * Sets the value of the specified <code>long</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setLong(Property property, long value);

	/**
	 * Sets the value of the specified <code>short</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setShort(Property property, short value);

	/**
	 * Sets the value of the specified <code>byte[]</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setBytes(Property property, byte[] value);

	/**
	 * Sets the value of the specified <code>BigDecimal</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setBigDecimal(Property property, BigDecimal value);

	/**
	 * Sets the value of the specified <code>BigInteger</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setBigInteger(Property property, BigInteger value);

	/**
	 * Sets the value of the specified <code>DataObject</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setDataObject(Property property, DataObject value);

	/**
	 * Sets the value of the specified <code>Date</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setDate(Property property, Date value);

	/**
	 * Sets the value of the specified <code>String</code> property, to the specified value.
	 * @param property the property to set.
	 * @param value the new value for the property.
	 * @see #set(Property, Object)
	 */
	void setString(Property property, String value);

	/**
	 * Returns the {@link DataGraph data graph} for this object or <code>null</code> if there isn't one.
	 * @return the containing data graph or <code>null</code>.
	 * @deprecated
	 */
	DataGraph getDataGraph();

	/**
	 * Returns the <code>Sequence</code> for this DataObject.
	 * When getType().isSequencedType() == true,
	 * the Sequence of a DataObject corresponds to the
	 * XML elements representing the values of its Properties.
	 * Updates through DataObject and the Lists or Sequences returned
	 * from DataObject operate on the same data.
	 * When getType().isSequencedType() == false, null is returned.  
	 * @return the <code>Sequence</code> or null.
	 */
	Sequence getSequence();

	/**
	 * @deprecated replaced by {@link #getInstanceProperty(String)} in 2.1.0
	 */
	Property getProperty(String propertyName);

	/**
	 * Returns the root {@link DataObject data object}.
	 * @return the root data object.
	 */
	DataObject getRootObject();

}